// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_IDL_DDSDCPSCOREC_ABICK8_H_
#define _TAO_IDL_DDSDCPSCOREC_ABICK8_H_

#include /**/ "ace/pre.h"


#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "dds/DCPS/dcps_export.h"
#include "tao/ORB.h"
#include "tao/Basic_Types.h"
#include "dds/DCPS/ZeroCopyInfoSeq_T.h"
#include "tao/String_Manager_T.h"
#include "tao/Sequence_T.h"
#include "tao/Seq_Var_T.h"
#include "tao/Seq_Out_T.h"
#include "tao/VarOut_T.h"
#include "tao/Array_VarOut_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Basic_Argument_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include "tao/UB_String_Arguments.h"
#include "tao/Fixed_Array_Argument_T.h"
#include "tao/Var_Array_Argument_T.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"
#include /**/ "dds/Versioned_Namespace.h"

#include "tao/StringSeqC.h"
#include "tao/LongSeqC.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO OpenDDS_Dcps_Export

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace DDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_STRINGSEQ_CH_)
#define _DDS_STRINGSEQ_CH_

  class StringSeq;

  typedef
    ::TAO_VarSeq_Var_T<
        StringSeq
      >
    StringSeq_var;

  typedef
    ::TAO_Seq_Out_T<
        StringSeq
      >
    StringSeq_out;

  class OpenDDS_Dcps_Export StringSeq
    : public
        ::TAO::unbounded_basic_string_sequence<char>
  {
  public:
    StringSeq (void);
    StringSeq ( ::CORBA::ULong max);
    StringSeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      ::CORBA::Char ** buffer,
      ::CORBA::Boolean release = false);
    StringSeq (const StringSeq &);
    virtual ~StringSeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef StringSeq_var _var_type;
    typedef StringSeq_out _out_type;
  };

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::Long InstanceHandle_t;
  typedef ::CORBA::Long_out InstanceHandle_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_array/array_ch.cpp:54

  typedef ::CORBA::Long BuiltinTopicKeyValue[3];
  typedef ::CORBA::Long BuiltinTopicKeyValue_slice;
  struct BuiltinTopicKeyValue_tag {};
  

  typedef
    TAO_FixedArray_Var_T<
        BuiltinTopicKeyValue,
        BuiltinTopicKeyValue_slice,
        BuiltinTopicKeyValue_tag
      >
    BuiltinTopicKeyValue_var;

  typedef
    BuiltinTopicKeyValue
    BuiltinTopicKeyValue_out;

  typedef
    TAO_Array_Forany_T<
        BuiltinTopicKeyValue,
        BuiltinTopicKeyValue_slice,
        BuiltinTopicKeyValue_tag
      >
    BuiltinTopicKeyValue_forany;

  TAO_NAMESPACE_STORAGE_CLASS BuiltinTopicKeyValue_slice *
  BuiltinTopicKeyValue_alloc (void);

  TAO_NAMESPACE_STORAGE_CLASS void
  BuiltinTopicKeyValue_free (
      BuiltinTopicKeyValue_slice *_tao_slice);
  
  TAO_NAMESPACE_STORAGE_CLASS BuiltinTopicKeyValue_slice *
  BuiltinTopicKeyValue_dup (
      const BuiltinTopicKeyValue_slice *_tao_slice);
  
  TAO_NAMESPACE_STORAGE_CLASS void
  BuiltinTopicKeyValue_copy (
      BuiltinTopicKeyValue_slice *_tao_to,
      const BuiltinTopicKeyValue_slice *_tao_from);

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_INSTANCEHANDLESEQ_CH_)
#define _DDS_INSTANCEHANDLESEQ_CH_

  class InstanceHandleSeq;

  typedef
    ::TAO_FixedSeq_Var_T<
        InstanceHandleSeq
      >
    InstanceHandleSeq_var;

  typedef
    ::TAO_Seq_Out_T<
        InstanceHandleSeq
      >
    InstanceHandleSeq_out;

  class OpenDDS_Dcps_Export InstanceHandleSeq
    : public
        ::TAO::unbounded_value_sequence<
            InstanceHandle_t
          >
  {
  public:
    InstanceHandleSeq (void);
    InstanceHandleSeq ( ::CORBA::ULong max);
    InstanceHandleSeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      ::CORBA::Long* buffer,
      ::CORBA::Boolean release = false);
    InstanceHandleSeq (const InstanceHandleSeq &);
    virtual ~InstanceHandleSeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef InstanceHandleSeq_var _var_type;
    typedef InstanceHandleSeq_out _out_type;
  };

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::Long QosPolicyId_t;
  typedef ::CORBA::Long_out QosPolicyId_t_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct QosPolicyCount;

  typedef
    ::TAO_Fixed_Var_T<
        QosPolicyCount
      >
    QosPolicyCount_var;

  typedef
    QosPolicyCount &
    QosPolicyCount_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export QosPolicyCount
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef QosPolicyCount_var _var_type;
    typedef QosPolicyCount_out _out_type;
    
    DDS::QosPolicyId_t policy_id;
    ::CORBA::Long count;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_QOSPOLICYCOUNTSEQ_CH_)
#define _DDS_QOSPOLICYCOUNTSEQ_CH_

  class QosPolicyCountSeq;

  typedef
    ::TAO_FixedSeq_Var_T<
        QosPolicyCountSeq
      >
    QosPolicyCountSeq_var;

  typedef
    ::TAO_Seq_Out_T<
        QosPolicyCountSeq
      >
    QosPolicyCountSeq_out;

  class OpenDDS_Dcps_Export QosPolicyCountSeq
    : public
        ::TAO::unbounded_value_sequence<
            QosPolicyCount
          >
  {
  public:
    QosPolicyCountSeq (void);
    QosPolicyCountSeq ( ::CORBA::ULong max);
    QosPolicyCountSeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      QosPolicyCount* buffer,
      ::CORBA::Boolean release = false);
    QosPolicyCountSeq (const QosPolicyCountSeq &);
    virtual ~QosPolicyCountSeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef QosPolicyCountSeq_var _var_type;
    typedef QosPolicyCountSeq_out _out_type;
  };

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_OCTETSEQ_CH_)
#define _DDS_OCTETSEQ_CH_

  class OctetSeq;

  typedef
    ::TAO_FixedSeq_Var_T<
        OctetSeq
      >
    OctetSeq_var;

  typedef
    ::TAO_Seq_Out_T<
        OctetSeq
      >
    OctetSeq_out;

  class OpenDDS_Dcps_Export OctetSeq
    : public
        ::TAO::unbounded_value_sequence<
            ::CORBA::Octet
          >
  {
  public:
    OctetSeq (void);
    OctetSeq ( ::CORBA::ULong max);
    OctetSeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      ::CORBA::Octet* buffer,
      ::CORBA::Boolean release = false);
    OctetSeq (const OctetSeq &);
    virtual ~OctetSeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef OctetSeq_var _var_type;
    typedef OctetSeq_out _out_type;

    

#if (TAO_NO_COPY_OCTET_SEQUENCES == 1)
    OctetSeq (
        ::CORBA::ULong length,
        const ACE_Message_Block* mb
      )
      : ::TAO::unbounded_value_sequence< ::CORBA::Octet> (length, mb) {}
#endif /* TAO_NO_COPY_OCTET_SEQUENCE == 1 */
  };

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct Duration_t;

  typedef
    ::TAO_Fixed_Var_T<
        Duration_t
      >
    Duration_t_var;

  typedef
    Duration_t &
    Duration_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export Duration_t
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef Duration_t_var _var_type;
    typedef Duration_t_out _out_type;
    
    ::CORBA::Long sec;
    ::CORBA::ULong nanosec;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long DURATION_INFINITE_SEC = 2147483647;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong DURATION_INFINITE_NSEC = 2147483647U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long DURATION_ZERO_SEC = 0;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong DURATION_ZERO_NSEC = 0U;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct Property_t;

  typedef
    ::TAO_Var_Var_T<
        Property_t
      >
    Property_t_var;

  typedef
    ::TAO_Out_T<
        Property_t
      >
    Property_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export Property_t
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef Property_t_var _var_type;
    typedef Property_t_out _out_type;
    
    ::TAO::String_Manager name;
    ::TAO::String_Manager value;
    ::CORBA::Boolean propagate;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_PROPERTYSEQ_CH_)
#define _DDS_PROPERTYSEQ_CH_

  class PropertySeq;

  typedef
    ::TAO_VarSeq_Var_T<
        PropertySeq
      >
    PropertySeq_var;

  typedef
    ::TAO_Seq_Out_T<
        PropertySeq
      >
    PropertySeq_out;

  class OpenDDS_Dcps_Export PropertySeq
    : public
        ::TAO::unbounded_value_sequence<
            Property_t
          >
  {
  public:
    PropertySeq (void);
    PropertySeq ( ::CORBA::ULong max);
    PropertySeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      Property_t* buffer,
      ::CORBA::Boolean release = false);
    PropertySeq (const PropertySeq &);
    virtual ~PropertySeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PropertySeq_var _var_type;
    typedef PropertySeq_out _out_type;
  };

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct BinaryProperty_t;

  typedef
    ::TAO_Var_Var_T<
        BinaryProperty_t
      >
    BinaryProperty_t_var;

  typedef
    ::TAO_Out_T<
        BinaryProperty_t
      >
    BinaryProperty_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export BinaryProperty_t
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef BinaryProperty_t_var _var_type;
    typedef BinaryProperty_t_out _out_type;
    
    ::TAO::String_Manager name;
    DDS::OctetSeq value;
    ::CORBA::Boolean propagate;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_BINARYPROPERTYSEQ_CH_)
#define _DDS_BINARYPROPERTYSEQ_CH_

  class BinaryPropertySeq;

  typedef
    ::TAO_VarSeq_Var_T<
        BinaryPropertySeq
      >
    BinaryPropertySeq_var;

  typedef
    ::TAO_Seq_Out_T<
        BinaryPropertySeq
      >
    BinaryPropertySeq_out;

  class OpenDDS_Dcps_Export BinaryPropertySeq
    : public
        ::TAO::unbounded_value_sequence<
            BinaryProperty_t
          >
  {
  public:
    BinaryPropertySeq (void);
    BinaryPropertySeq ( ::CORBA::ULong max);
    BinaryPropertySeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      BinaryProperty_t* buffer,
      ::CORBA::Boolean release = false);
    BinaryPropertySeq (const BinaryPropertySeq &);
    virtual ~BinaryPropertySeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef BinaryPropertySeq_var _var_type;
    typedef BinaryPropertySeq_out _out_type;
  };

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct PropertyQosPolicy;

  typedef
    ::TAO_Var_Var_T<
        PropertyQosPolicy
      >
    PropertyQosPolicy_var;

  typedef
    ::TAO_Out_T<
        PropertyQosPolicy
      >
    PropertyQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export PropertyQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PropertyQosPolicy_var _var_type;
    typedef PropertyQosPolicy_out _out_type;
    
    DDS::PropertySeq value;
    DDS::BinaryPropertySeq binary_value;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct UserDataQosPolicy;

  typedef
    ::TAO_Var_Var_T<
        UserDataQosPolicy
      >
    UserDataQosPolicy_var;

  typedef
    ::TAO_Out_T<
        UserDataQosPolicy
      >
    UserDataQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export UserDataQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef UserDataQosPolicy_var _var_type;
    typedef UserDataQosPolicy_out _out_type;
    
    DDS::OctetSeq value;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct GroupDataQosPolicy;

  typedef
    ::TAO_Var_Var_T<
        GroupDataQosPolicy
      >
    GroupDataQosPolicy_var;

  typedef
    ::TAO_Out_T<
        GroupDataQosPolicy
      >
    GroupDataQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export GroupDataQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef GroupDataQosPolicy_var _var_type;
    typedef GroupDataQosPolicy_out _out_type;
    
    DDS::OctetSeq value;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct TopicDataQosPolicy;

  typedef
    ::TAO_Var_Var_T<
        TopicDataQosPolicy
      >
    TopicDataQosPolicy_var;

  typedef
    ::TAO_Out_T<
        TopicDataQosPolicy
      >
    TopicDataQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export TopicDataQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef TopicDataQosPolicy_var _var_type;
    typedef TopicDataQosPolicy_out _out_type;
    
    DDS::OctetSeq value;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct PartitionQosPolicy;

  typedef
    ::TAO_Var_Var_T<
        PartitionQosPolicy
      >
    PartitionQosPolicy_var;

  typedef
    ::TAO_Out_T<
        PartitionQosPolicy
      >
    PartitionQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export PartitionQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PartitionQosPolicy_var _var_type;
    typedef PartitionQosPolicy_out _out_type;
    
    DDS::StringSeq name;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum HistoryQosPolicyKind
  {
    KEEP_LAST_HISTORY_QOS,
    KEEP_ALL_HISTORY_QOS
  };

  typedef HistoryQosPolicyKind &HistoryQosPolicyKind_out;

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum DurabilityQosPolicyKind
  {
    VOLATILE_DURABILITY_QOS,
    TRANSIENT_LOCAL_DURABILITY_QOS,
    TRANSIENT_DURABILITY_QOS,
    PERSISTENT_DURABILITY_QOS
  };

  typedef DurabilityQosPolicyKind &DurabilityQosPolicyKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DurabilityQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        DurabilityQosPolicy
      >
    DurabilityQosPolicy_var;

  typedef
    DurabilityQosPolicy &
    DurabilityQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DurabilityQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DurabilityQosPolicy_var _var_type;
    typedef DurabilityQosPolicy_out _out_type;
    
    DDS::DurabilityQosPolicyKind kind;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DurabilityServiceQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        DurabilityServiceQosPolicy
      >
    DurabilityServiceQosPolicy_var;

  typedef
    DurabilityServiceQosPolicy &
    DurabilityServiceQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DurabilityServiceQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DurabilityServiceQosPolicy_var _var_type;
    typedef DurabilityServiceQosPolicy_out _out_type;
    
    DDS::Duration_t service_cleanup_delay;
    DDS::HistoryQosPolicyKind history_kind;
    ::CORBA::Long history_depth;
    ::CORBA::Long max_samples;
    ::CORBA::Long max_instances;
    ::CORBA::Long max_samples_per_instance;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DeadlineQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        DeadlineQosPolicy
      >
    DeadlineQosPolicy_var;

  typedef
    DeadlineQosPolicy &
    DeadlineQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DeadlineQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DeadlineQosPolicy_var _var_type;
    typedef DeadlineQosPolicy_out _out_type;
    
    DDS::Duration_t period;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct LatencyBudgetQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        LatencyBudgetQosPolicy
      >
    LatencyBudgetQosPolicy_var;

  typedef
    LatencyBudgetQosPolicy &
    LatencyBudgetQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export LatencyBudgetQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef LatencyBudgetQosPolicy_var _var_type;
    typedef LatencyBudgetQosPolicy_out _out_type;
    
    DDS::Duration_t duration;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum LivelinessQosPolicyKind
  {
    AUTOMATIC_LIVELINESS_QOS,
    MANUAL_BY_PARTICIPANT_LIVELINESS_QOS,
    MANUAL_BY_TOPIC_LIVELINESS_QOS
  };

  typedef LivelinessQosPolicyKind &LivelinessQosPolicyKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct LivelinessQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        LivelinessQosPolicy
      >
    LivelinessQosPolicy_var;

  typedef
    LivelinessQosPolicy &
    LivelinessQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export LivelinessQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef LivelinessQosPolicy_var _var_type;
    typedef LivelinessQosPolicy_out _out_type;
    
    DDS::LivelinessQosPolicyKind kind;
    DDS::Duration_t lease_duration;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum ReliabilityQosPolicyKind
  {
    BEST_EFFORT_RELIABILITY_QOS,
    RELIABLE_RELIABILITY_QOS
  };

  typedef ReliabilityQosPolicyKind &ReliabilityQosPolicyKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct ReliabilityQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        ReliabilityQosPolicy
      >
    ReliabilityQosPolicy_var;

  typedef
    ReliabilityQosPolicy &
    ReliabilityQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export ReliabilityQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef ReliabilityQosPolicy_var _var_type;
    typedef ReliabilityQosPolicy_out _out_type;
    
    DDS::ReliabilityQosPolicyKind kind;
    DDS::Duration_t max_blocking_time;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum DestinationOrderQosPolicyKind
  {
    BY_RECEPTION_TIMESTAMP_DESTINATIONORDER_QOS,
    BY_SOURCE_TIMESTAMP_DESTINATIONORDER_QOS
  };

  typedef DestinationOrderQosPolicyKind &DestinationOrderQosPolicyKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DestinationOrderQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        DestinationOrderQosPolicy
      >
    DestinationOrderQosPolicy_var;

  typedef
    DestinationOrderQosPolicy &
    DestinationOrderQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DestinationOrderQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DestinationOrderQosPolicy_var _var_type;
    typedef DestinationOrderQosPolicy_out _out_type;
    
    DDS::DestinationOrderQosPolicyKind kind;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct HistoryQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        HistoryQosPolicy
      >
    HistoryQosPolicy_var;

  typedef
    HistoryQosPolicy &
    HistoryQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export HistoryQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef HistoryQosPolicy_var _var_type;
    typedef HistoryQosPolicy_out _out_type;
    
    DDS::HistoryQosPolicyKind kind;
    ::CORBA::Long depth;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct ResourceLimitsQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        ResourceLimitsQosPolicy
      >
    ResourceLimitsQosPolicy_var;

  typedef
    ResourceLimitsQosPolicy &
    ResourceLimitsQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export ResourceLimitsQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef ResourceLimitsQosPolicy_var _var_type;
    typedef ResourceLimitsQosPolicy_out _out_type;
    
    ::CORBA::Long max_samples;
    ::CORBA::Long max_instances;
    ::CORBA::Long max_samples_per_instance;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct TransportPriorityQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        TransportPriorityQosPolicy
      >
    TransportPriorityQosPolicy_var;

  typedef
    TransportPriorityQosPolicy &
    TransportPriorityQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export TransportPriorityQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef TransportPriorityQosPolicy_var _var_type;
    typedef TransportPriorityQosPolicy_out _out_type;
    
    ::CORBA::Long value;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct LifespanQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        LifespanQosPolicy
      >
    LifespanQosPolicy_var;

  typedef
    LifespanQosPolicy &
    LifespanQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export LifespanQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef LifespanQosPolicy_var _var_type;
    typedef LifespanQosPolicy_out _out_type;
    
    DDS::Duration_t duration;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum OwnershipQosPolicyKind
  {
    SHARED_OWNERSHIP_QOS,
    EXCLUSIVE_OWNERSHIP_QOS
  };

  typedef OwnershipQosPolicyKind &OwnershipQosPolicyKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct OwnershipQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        OwnershipQosPolicy
      >
    OwnershipQosPolicy_var;

  typedef
    OwnershipQosPolicy &
    OwnershipQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export OwnershipQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef OwnershipQosPolicy_var _var_type;
    typedef OwnershipQosPolicy_out _out_type;
    
    DDS::OwnershipQosPolicyKind kind;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct OwnershipStrengthQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        OwnershipStrengthQosPolicy
      >
    OwnershipStrengthQosPolicy_var;

  typedef
    OwnershipStrengthQosPolicy &
    OwnershipStrengthQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export OwnershipStrengthQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef OwnershipStrengthQosPolicy_var _var_type;
    typedef OwnershipStrengthQosPolicy_out _out_type;
    
    ::CORBA::Long value;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_enum/enum_ch.cpp:47

  enum PresentationQosPolicyAccessScopeKind
  {
    INSTANCE_PRESENTATION_QOS,
    TOPIC_PRESENTATION_QOS,
    GROUP_PRESENTATION_QOS
  };

  typedef PresentationQosPolicyAccessScopeKind &PresentationQosPolicyAccessScopeKind_out;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct PresentationQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        PresentationQosPolicy
      >
    PresentationQosPolicy_var;

  typedef
    PresentationQosPolicy &
    PresentationQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export PresentationQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PresentationQosPolicy_var _var_type;
    typedef PresentationQosPolicy_out _out_type;
    
    DDS::PresentationQosPolicyAccessScopeKind access_scope;
    ::CORBA::Boolean coherent_access;
    ::CORBA::Boolean ordered_access;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct TimeBasedFilterQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        TimeBasedFilterQosPolicy
      >
    TimeBasedFilterQosPolicy_var;

  typedef
    TimeBasedFilterQosPolicy &
    TimeBasedFilterQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export TimeBasedFilterQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef TimeBasedFilterQosPolicy_var _var_type;
    typedef TimeBasedFilterQosPolicy_out _out_type;
    
    DDS::Duration_t minimum_separation;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct TopicQos;

  typedef
    ::TAO_Var_Var_T<
        TopicQos
      >
    TopicQos_var;

  typedef
    ::TAO_Out_T<
        TopicQos
      >
    TopicQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export TopicQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef TopicQos_var _var_type;
    typedef TopicQos_out _out_type;
    
    DDS::TopicDataQosPolicy topic_data;
    DDS::DurabilityQosPolicy durability;
    DDS::DurabilityServiceQosPolicy durability_service;
    DDS::DeadlineQosPolicy deadline;
    DDS::LatencyBudgetQosPolicy latency_budget;
    DDS::LivelinessQosPolicy liveliness;
    DDS::ReliabilityQosPolicy reliability;
    DDS::DestinationOrderQosPolicy destination_order;
    DDS::HistoryQosPolicy history;
    DDS::ResourceLimitsQosPolicy resource_limits;
    DDS::TransportPriorityQosPolicy transport_priority;
    DDS::LifespanQosPolicy lifespan;
    DDS::OwnershipQosPolicy ownership;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct WriterDataLifecycleQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        WriterDataLifecycleQosPolicy
      >
    WriterDataLifecycleQosPolicy_var;

  typedef
    WriterDataLifecycleQosPolicy &
    WriterDataLifecycleQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export WriterDataLifecycleQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef WriterDataLifecycleQosPolicy_var _var_type;
    typedef WriterDataLifecycleQosPolicy_out _out_type;
    
    ::CORBA::Boolean autodispose_unregistered_instances;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DataWriterQos;

  typedef
    ::TAO_Var_Var_T<
        DataWriterQos
      >
    DataWriterQos_var;

  typedef
    ::TAO_Out_T<
        DataWriterQos
      >
    DataWriterQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DataWriterQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DataWriterQos_var _var_type;
    typedef DataWriterQos_out _out_type;
    
    DDS::DurabilityQosPolicy durability;
    DDS::DurabilityServiceQosPolicy durability_service;
    DDS::DeadlineQosPolicy deadline;
    DDS::LatencyBudgetQosPolicy latency_budget;
    DDS::LivelinessQosPolicy liveliness;
    DDS::ReliabilityQosPolicy reliability;
    DDS::DestinationOrderQosPolicy destination_order;
    DDS::HistoryQosPolicy history;
    DDS::ResourceLimitsQosPolicy resource_limits;
    DDS::TransportPriorityQosPolicy transport_priority;
    DDS::LifespanQosPolicy lifespan;
    DDS::UserDataQosPolicy user_data;
    DDS::OwnershipQosPolicy ownership;
    DDS::OwnershipStrengthQosPolicy ownership_strength;
    DDS::WriterDataLifecycleQosPolicy writer_data_lifecycle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct EntityFactoryQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        EntityFactoryQosPolicy
      >
    EntityFactoryQosPolicy_var;

  typedef
    EntityFactoryQosPolicy &
    EntityFactoryQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export EntityFactoryQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef EntityFactoryQosPolicy_var _var_type;
    typedef EntityFactoryQosPolicy_out _out_type;
    
    ::CORBA::Boolean autoenable_created_entities;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct PublisherQos;

  typedef
    ::TAO_Var_Var_T<
        PublisherQos
      >
    PublisherQos_var;

  typedef
    ::TAO_Out_T<
        PublisherQos
      >
    PublisherQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export PublisherQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PublisherQos_var _var_type;
    typedef PublisherQos_out _out_type;
    
    DDS::PresentationQosPolicy presentation;
    DDS::PartitionQosPolicy partition;
    DDS::GroupDataQosPolicy group_data;
    DDS::EntityFactoryQosPolicy entity_factory;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct ReaderDataLifecycleQosPolicy;

  typedef
    ::TAO_Fixed_Var_T<
        ReaderDataLifecycleQosPolicy
      >
    ReaderDataLifecycleQosPolicy_var;

  typedef
    ReaderDataLifecycleQosPolicy &
    ReaderDataLifecycleQosPolicy_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export ReaderDataLifecycleQosPolicy
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef ReaderDataLifecycleQosPolicy_var _var_type;
    typedef ReaderDataLifecycleQosPolicy_out _out_type;
    
    DDS::Duration_t autopurge_nowriter_samples_delay;
    DDS::Duration_t autopurge_disposed_samples_delay;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DataReaderQos;

  typedef
    ::TAO_Var_Var_T<
        DataReaderQos
      >
    DataReaderQos_var;

  typedef
    ::TAO_Out_T<
        DataReaderQos
      >
    DataReaderQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DataReaderQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DataReaderQos_var _var_type;
    typedef DataReaderQos_out _out_type;
    
    DDS::DurabilityQosPolicy durability;
    DDS::DeadlineQosPolicy deadline;
    DDS::LatencyBudgetQosPolicy latency_budget;
    DDS::LivelinessQosPolicy liveliness;
    DDS::ReliabilityQosPolicy reliability;
    DDS::DestinationOrderQosPolicy destination_order;
    DDS::HistoryQosPolicy history;
    DDS::ResourceLimitsQosPolicy resource_limits;
    DDS::UserDataQosPolicy user_data;
    DDS::OwnershipQosPolicy ownership;
    DDS::TimeBasedFilterQosPolicy time_based_filter;
    DDS::ReaderDataLifecycleQosPolicy reader_data_lifecycle;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct SubscriberQos;

  typedef
    ::TAO_Var_Var_T<
        SubscriberQos
      >
    SubscriberQos_var;

  typedef
    ::TAO_Out_T<
        SubscriberQos
      >
    SubscriberQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export SubscriberQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SubscriberQos_var _var_type;
    typedef SubscriberQos_out _out_type;
    
    DDS::PresentationQosPolicy presentation;
    DDS::PartitionQosPolicy partition;
    DDS::GroupDataQosPolicy group_data;
    DDS::EntityFactoryQosPolicy entity_factory;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DomainParticipantFactoryQos;

  typedef
    ::TAO_Fixed_Var_T<
        DomainParticipantFactoryQos
      >
    DomainParticipantFactoryQos_var;

  typedef
    DomainParticipantFactoryQos &
    DomainParticipantFactoryQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DomainParticipantFactoryQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DomainParticipantFactoryQos_var _var_type;
    typedef DomainParticipantFactoryQos_out _out_type;
    
    DDS::EntityFactoryQosPolicy entity_factory;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct DomainParticipantQos;

  typedef
    ::TAO_Var_Var_T<
        DomainParticipantQos
      >
    DomainParticipantQos_var;

  typedef
    ::TAO_Out_T<
        DomainParticipantQos
      >
    DomainParticipantQos_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export DomainParticipantQos
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef DomainParticipantQos_var _var_type;
    typedef DomainParticipantQos_out _out_type;
    
    DDS::UserDataQosPolicy user_data;
    DDS::EntityFactoryQosPolicy entity_factory;
    DDS::PropertyQosPolicy property;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct BuiltinTopicKey_t;

  typedef
    ::TAO_Fixed_Var_T<
        BuiltinTopicKey_t
      >
    BuiltinTopicKey_t_var;

  typedef
    BuiltinTopicKey_t &
    BuiltinTopicKey_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export BuiltinTopicKey_t
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef BuiltinTopicKey_t_var _var_type;
    typedef BuiltinTopicKey_t_out _out_type;
    
    DDS::BuiltinTopicKeyValue value;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct ParticipantBuiltinTopicData;

  typedef
    ::TAO_Var_Var_T<
        ParticipantBuiltinTopicData
      >
    ParticipantBuiltinTopicData_var;

  typedef
    ::TAO_Out_T<
        ParticipantBuiltinTopicData
      >
    ParticipantBuiltinTopicData_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export ParticipantBuiltinTopicData
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef ParticipantBuiltinTopicData_var _var_type;
    typedef ParticipantBuiltinTopicData_out _out_type;
    
    DDS::BuiltinTopicKey_t key;
    DDS::UserDataQosPolicy user_data;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct PublicationBuiltinTopicData;

  typedef
    ::TAO_Var_Var_T<
        PublicationBuiltinTopicData
      >
    PublicationBuiltinTopicData_var;

  typedef
    ::TAO_Out_T<
        PublicationBuiltinTopicData
      >
    PublicationBuiltinTopicData_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export PublicationBuiltinTopicData
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef PublicationBuiltinTopicData_var _var_type;
    typedef PublicationBuiltinTopicData_out _out_type;
    
    DDS::BuiltinTopicKey_t key;
    DDS::BuiltinTopicKey_t participant_key;
    ::TAO::String_Manager topic_name;
    ::TAO::String_Manager type_name;
    DDS::DurabilityQosPolicy durability;
    DDS::DurabilityServiceQosPolicy durability_service;
    DDS::DeadlineQosPolicy deadline;
    DDS::LatencyBudgetQosPolicy latency_budget;
    DDS::LivelinessQosPolicy liveliness;
    DDS::ReliabilityQosPolicy reliability;
    DDS::LifespanQosPolicy lifespan;
    DDS::UserDataQosPolicy user_data;
    DDS::OwnershipQosPolicy ownership;
    DDS::OwnershipStrengthQosPolicy ownership_strength;
    DDS::DestinationOrderQosPolicy destination_order;
    DDS::PresentationQosPolicy presentation;
    DDS::PartitionQosPolicy partition;
    DDS::TopicDataQosPolicy topic_data;
    DDS::GroupDataQosPolicy group_data;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct SubscriptionBuiltinTopicData;

  typedef
    ::TAO_Var_Var_T<
        SubscriptionBuiltinTopicData
      >
    SubscriptionBuiltinTopicData_var;

  typedef
    ::TAO_Out_T<
        SubscriptionBuiltinTopicData
      >
    SubscriptionBuiltinTopicData_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export SubscriptionBuiltinTopicData
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SubscriptionBuiltinTopicData_var _var_type;
    typedef SubscriptionBuiltinTopicData_out _out_type;
    
    DDS::BuiltinTopicKey_t key;
    DDS::BuiltinTopicKey_t participant_key;
    ::TAO::String_Manager topic_name;
    ::TAO::String_Manager type_name;
    DDS::DurabilityQosPolicy durability;
    DDS::DeadlineQosPolicy deadline;
    DDS::LatencyBudgetQosPolicy latency_budget;
    DDS::LivelinessQosPolicy liveliness;
    DDS::ReliabilityQosPolicy reliability;
    DDS::OwnershipQosPolicy ownership;
    DDS::DestinationOrderQosPolicy destination_order;
    DDS::UserDataQosPolicy user_data;
    DDS::TimeBasedFilterQosPolicy time_based_filter;
    DDS::PresentationQosPolicy presentation;
    DDS::PartitionQosPolicy partition;
    DDS::TopicDataQosPolicy topic_data;
    DDS::GroupDataQosPolicy group_data;
  };

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct TopicBuiltinTopicData;

  typedef
    ::TAO_Var_Var_T<
        TopicBuiltinTopicData
      >
    TopicBuiltinTopicData_var;

  typedef
    ::TAO_Out_T<
        TopicBuiltinTopicData
      >
    TopicBuiltinTopicData_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export TopicBuiltinTopicData
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef TopicBuiltinTopicData_var _var_type;
    typedef TopicBuiltinTopicData_out _out_type;
    
    DDS::BuiltinTopicKey_t key;
    ::TAO::String_Manager name;
    ::TAO::String_Manager type_name;
    DDS::DurabilityQosPolicy durability;
    DDS::DurabilityServiceQosPolicy durability_service;
    DDS::DeadlineQosPolicy deadline;
    DDS::LatencyBudgetQosPolicy latency_budget;
    DDS::LivelinessQosPolicy liveliness;
    DDS::ReliabilityQosPolicy reliability;
    DDS::TransportPriorityQosPolicy transport_priority;
    DDS::LifespanQosPolicy lifespan;
    DDS::DestinationOrderQosPolicy destination_order;
    DDS::HistoryQosPolicy history;
    DDS::ResourceLimitsQosPolicy resource_limits;
    DDS::OwnershipQosPolicy ownership;
    DDS::TopicDataQosPolicy topic_data;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong SampleStateKind;
  typedef ::CORBA::ULong_out SampleStateKind_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong READ_SAMPLE_STATE = 1U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong NOT_READ_SAMPLE_STATE = 2U;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong SampleStateMask;
  typedef ::CORBA::ULong_out SampleStateMask_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong ANY_SAMPLE_STATE = 65535U;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong ViewStateKind;
  typedef ::CORBA::ULong_out ViewStateKind_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong NEW_VIEW_STATE = 1U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong NOT_NEW_VIEW_STATE = 2U;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong ViewStateMask;
  typedef ::CORBA::ULong_out ViewStateMask_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong ANY_VIEW_STATE = 65535U;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong InstanceStateKind;
  typedef ::CORBA::ULong_out InstanceStateKind_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong ALIVE_INSTANCE_STATE = 1U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong NOT_ALIVE_DISPOSED_INSTANCE_STATE = 2U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong NOT_ALIVE_NO_WRITERS_INSTANCE_STATE = 4U;

  // TAO_IDL - Generated from
  // be/be_visitor_typedef/typedef_ch.cpp:373

  typedef ::CORBA::ULong InstanceStateMask;
  typedef ::CORBA::ULong_out InstanceStateMask_out;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong ANY_INSTANCE_STATE = 65535U;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong NOT_ALIVE_INSTANCE_STATE = 6U;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct Time_t;

  typedef
    ::TAO_Fixed_Var_T<
        Time_t
      >
    Time_t_var;

  typedef
    Time_t &
    Time_t_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export Time_t
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef Time_t_var _var_type;
    typedef Time_t_out _out_type;
    
    ::CORBA::Long sec;
    ::CORBA::ULong nanosec;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::Long TIME_INVALID_SEC = -1;

  // TAO_IDL - Generated from
  // be/be_visitor_constant/constant_ch.cpp:38

  const CORBA::ULong TIME_INVALID_NSEC = 4294967295U;

  // TAO_IDL - Generated from
  // be/be_type.cpp:261

  struct SampleInfo;

  typedef
    ::TAO_Fixed_Var_T<
        SampleInfo
      >
    SampleInfo_var;

  typedef
    SampleInfo &
    SampleInfo_out;

  // TAO_IDL - Generated from
  // be/be_visitor_structure/structure_ch.cpp:51

  struct OpenDDS_Dcps_Export SampleInfo
  {

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SampleInfo_var _var_type;
    typedef SampleInfo_out _out_type;
    
    DDS::SampleStateKind sample_state;
    DDS::ViewStateKind view_state;
    DDS::InstanceStateKind instance_state;
    DDS::Time_t source_timestamp;
    DDS::InstanceHandle_t instance_handle;
    DDS::InstanceHandle_t publication_handle;
    ::CORBA::Long disposed_generation_count;
    ::CORBA::Long no_writers_generation_count;
    ::CORBA::Long sample_rank;
    ::CORBA::Long generation_rank;
    ::CORBA::Long absolute_generation_rank;
    ::CORBA::Boolean valid_data;
    ::CORBA::LongLong opendds_reserved_publication_seq;
  };

  // TAO_IDL - Generated from
  // be/be_visitor_sequence/sequence_ch.cpp:102

#if !defined (_DDS_SAMPLEINFOSEQ_CH_)
#define _DDS_SAMPLEINFOSEQ_CH_

  class SampleInfoSeq;

  typedef
    ::TAO_FixedSeq_Var_T<
        SampleInfoSeq
      >
    SampleInfoSeq_var;

  typedef
    ::TAO_Seq_Out_T<
        SampleInfoSeq
      >
    SampleInfoSeq_out;

  class OpenDDS_Dcps_Export SampleInfoSeq
    : public
        ::TAO::unbounded_value_sequence<
            SampleInfo
          >
  {
  public:
    SampleInfoSeq (void);
    SampleInfoSeq ( ::CORBA::ULong max);
    SampleInfoSeq (
      ::CORBA::ULong max,
      ::CORBA::ULong length,
      SampleInfo* buffer,
      ::CORBA::Boolean release = false);
    SampleInfoSeq (const SampleInfoSeq &);
    virtual ~SampleInfoSeq (void);
    

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    
    typedef SampleInfoSeq_var _var_type;
    typedef SampleInfoSeq_out _out_type;
  };

#endif /* end #if !defined */

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module DDS

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::StringSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::StringSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  template<>
  class Arg_Traits< ::DDS::BuiltinTopicKeyValue_tag>
    : public
        Fixed_Array_Arg_Traits_T<
            ::DDS::BuiltinTopicKeyValue_var,
            ::DDS::BuiltinTopicKeyValue_forany,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::InstanceHandleSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::InstanceHandleSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::QosPolicyCount>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::QosPolicyCount,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::QosPolicyCountSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::QosPolicyCountSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::OctetSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::OctetSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::Duration_t>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::Duration_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::Property_t>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::Property_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::PropertySeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::PropertySeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::BinaryProperty_t>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::BinaryProperty_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::BinaryPropertySeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::BinaryPropertySeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::PropertyQosPolicy>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::PropertyQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::UserDataQosPolicy>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::UserDataQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::GroupDataQosPolicy>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::GroupDataQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::TopicDataQosPolicy>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::TopicDataQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::PartitionQosPolicy>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::PartitionQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::HistoryQosPolicyKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::HistoryQosPolicyKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::DurabilityQosPolicyKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::DurabilityQosPolicyKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DurabilityQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::DurabilityQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DurabilityServiceQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::DurabilityServiceQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DeadlineQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::DeadlineQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::LatencyBudgetQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::LatencyBudgetQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::LivelinessQosPolicyKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::LivelinessQosPolicyKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::LivelinessQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::LivelinessQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::ReliabilityQosPolicyKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::ReliabilityQosPolicyKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::ReliabilityQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::ReliabilityQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::DestinationOrderQosPolicyKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::DestinationOrderQosPolicyKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DestinationOrderQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::DestinationOrderQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::HistoryQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::HistoryQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::ResourceLimitsQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::ResourceLimitsQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::TransportPriorityQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::TransportPriorityQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::LifespanQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::LifespanQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::OwnershipQosPolicyKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::OwnershipQosPolicyKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::OwnershipQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::OwnershipQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::OwnershipStrengthQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::OwnershipStrengthQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::DDS::PresentationQosPolicyAccessScopeKind>
    : public
        Basic_Arg_Traits_T<
            ::DDS::PresentationQosPolicyAccessScopeKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::PresentationQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::PresentationQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::TimeBasedFilterQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::TimeBasedFilterQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::TopicQos>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::TopicQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::WriterDataLifecycleQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::WriterDataLifecycleQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DataWriterQos>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::DataWriterQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::EntityFactoryQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::EntityFactoryQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::PublisherQos>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::PublisherQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::ReaderDataLifecycleQosPolicy>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::ReaderDataLifecycleQosPolicy,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DataReaderQos>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::DataReaderQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::SubscriberQos>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::SubscriberQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DomainParticipantFactoryQos>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::DomainParticipantFactoryQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::DomainParticipantQos>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::DomainParticipantQos,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::BuiltinTopicKey_t>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::BuiltinTopicKey_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::ParticipantBuiltinTopicData>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::ParticipantBuiltinTopicData,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::PublicationBuiltinTopicData>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::PublicationBuiltinTopicData,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::SubscriptionBuiltinTopicData>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::SubscriptionBuiltinTopicData,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::TopicBuiltinTopicData>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::TopicBuiltinTopicData,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::Time_t>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::Time_t,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::DDS::SampleInfo>
    : public
        Fixed_Size_Arg_Traits_T<
            ::DDS::SampleInfo,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class Arg_Traits< ::DDS::SampleInfoSeq>
    : public
        Var_Size_Arg_Traits_T<
            ::DDS::SampleInfoSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{
  template<>
  struct OpenDDS_Dcps_Export Array_Traits<
      DDS::BuiltinTopicKeyValue_forany
    >
  {
    static void free (
        DDS::BuiltinTopicKeyValue_slice * _tao_slice);
    static DDS::BuiltinTopicKeyValue_slice * dup (
        const DDS::BuiltinTopicKeyValue_slice * _tao_slice);
    static void copy (
        DDS::BuiltinTopicKeyValue_slice * _tao_to,
        const DDS::BuiltinTopicKeyValue_slice * _tao_from);
    static DDS::BuiltinTopicKeyValue_slice * alloc (void);
    static void zero (
        DDS::BuiltinTopicKeyValue_slice * _tao_slice);
  };
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_StringSeq_H_
#define _TAO_CDR_OP_DDS_StringSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::StringSeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::StringSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_StringSeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_array/cdr_op_ch.cpp:102



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export CORBA::Boolean operator<< (TAO_OutputCDR &strm, const DDS::BuiltinTopicKeyValue_forany &_tao_array);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::BuiltinTopicKeyValue_forany &_tao_array);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_InstanceHandleSeq_H_
#define _TAO_CDR_OP_DDS_InstanceHandleSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::InstanceHandleSeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::InstanceHandleSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_InstanceHandleSeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::QosPolicyCount &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::QosPolicyCount &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_QosPolicyCountSeq_H_
#define _TAO_CDR_OP_DDS_QosPolicyCountSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::QosPolicyCountSeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::QosPolicyCountSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_QosPolicyCountSeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_OctetSeq_H_
#define _TAO_CDR_OP_DDS_OctetSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::OctetSeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::OctetSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_OctetSeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::Duration_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::Duration_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::Property_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::Property_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_PropertySeq_H_
#define _TAO_CDR_OP_DDS_PropertySeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::PropertySeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::PropertySeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_PropertySeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::BinaryProperty_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::BinaryProperty_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_BinaryPropertySeq_H_
#define _TAO_CDR_OP_DDS_BinaryPropertySeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::BinaryPropertySeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::BinaryPropertySeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_BinaryPropertySeq_H_ */

// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::PropertyQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::PropertyQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::UserDataQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::UserDataQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::GroupDataQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::GroupDataQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::TopicDataQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::TopicDataQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::PartitionQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::PartitionQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::HistoryQosPolicyKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::HistoryQosPolicyKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::DurabilityQosPolicyKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::DurabilityQosPolicyKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DurabilityQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DurabilityQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DurabilityServiceQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DurabilityServiceQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DeadlineQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DeadlineQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::LatencyBudgetQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::LatencyBudgetQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::LivelinessQosPolicyKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::LivelinessQosPolicyKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::LivelinessQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::LivelinessQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::ReliabilityQosPolicyKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::ReliabilityQosPolicyKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::ReliabilityQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::ReliabilityQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::DestinationOrderQosPolicyKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::DestinationOrderQosPolicyKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DestinationOrderQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DestinationOrderQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::HistoryQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::HistoryQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::ResourceLimitsQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::ResourceLimitsQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::TransportPriorityQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::TransportPriorityQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::LifespanQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::LifespanQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::OwnershipQosPolicyKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::OwnershipQosPolicyKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::OwnershipQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::OwnershipQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::OwnershipStrengthQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::OwnershipStrengthQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, DDS::PresentationQosPolicyAccessScopeKind _tao_enumerator);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, DDS::PresentationQosPolicyAccessScopeKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::PresentationQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::PresentationQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::TimeBasedFilterQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::TimeBasedFilterQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::TopicQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::TopicQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::WriterDataLifecycleQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::WriterDataLifecycleQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DataWriterQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DataWriterQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::EntityFactoryQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::EntityFactoryQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::PublisherQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::PublisherQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::ReaderDataLifecycleQosPolicy &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::ReaderDataLifecycleQosPolicy &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DataReaderQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DataReaderQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::SubscriberQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::SubscriberQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DomainParticipantFactoryQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DomainParticipantFactoryQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::DomainParticipantQos &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::DomainParticipantQos &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::BuiltinTopicKey_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::BuiltinTopicKey_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::ParticipantBuiltinTopicData &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::ParticipantBuiltinTopicData &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::PublicationBuiltinTopicData &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::PublicationBuiltinTopicData &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::SubscriptionBuiltinTopicData &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::SubscriptionBuiltinTopicData &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::TopicBuiltinTopicData &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::TopicBuiltinTopicData &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::Time_t &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::Time_t &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const DDS::SampleInfo &);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, DDS::SampleInfo &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_sequence/cdr_op_ch.cpp:68

#if !defined _TAO_CDR_OP_DDS_SampleInfoSeq_H_
#define _TAO_CDR_OP_DDS_SampleInfoSeq_H_

OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


OpenDDS_Dcps_Export ::CORBA::Boolean operator<< (
    TAO_OutputCDR &strm,
    const DDS::SampleInfoSeq &_tao_sequence);
OpenDDS_Dcps_Export ::CORBA::Boolean operator>> (
    TAO_InputCDR &strm,
    DDS::SampleInfoSeq &_tao_sequence);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




#endif /* _TAO_CDR_OP_DDS_SampleInfoSeq_H_ */

// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


OPENDDS_END_VERSIONED_NAMESPACE_DECL

#if defined (__ACE_INLINE__)
#include "DdsDcpsCoreC.inl"
#endif /* defined INLINE */

#include /**/ "ace/post.h"

#endif /* ifndef */

